from random import *
from z3 import *

x = Function('x', IntSort(), IntSort())

M = 100
N = 50

s = Solver()
idxs = sample(xrange(M),N) # get N random ids from sequence {1,...M}
print idxs

distinctlist = []
for i in range(M):
  s.add(And(x(i) >= 1, x(i) <= N))
  if i in idxs:
    distinctlist.append(x(i))

print distinctlist

s.add(Distinct(distinctlist))

print "checking..."

r = s.check()
print r
if r == sat:
  print s.model()
